#include "example_autonomy_protocol.h"

namespace game_engine {

// BuildHistoryVectors produces vectors containing sampled versions of the of
// the trajectories generated by P4.  It also serves as an example of a
// file-scope helper function such as you can build for your own purposes.
void BuildHistoryVectors(const std::vector<double>& timestamps,
                         const p4::PolynomialSolver::Solution& trajectory,
                         const p4::PolynomialSampler& sampler_options,
                         std::vector<double>& x_hist,
                         std::vector<double>& y_hist,
                         std::vector<double>& z_hist) {
  // Use this object to sample the trajectory
  p4::PolynomialSampler sampler(sampler_options);
  const Eigen::MatrixXd samples = sampler.Run(timestamps, trajectory);

  for (size_t i = 0; i < samples.cols(); ++i) {
    x_hist.push_back(samples(1, i));
    y_hist.push_back(samples(2, i));
    z_hist.push_back(samples(3, i));
  }
}

// UpdateTrajectories creates and returns a proposed trajectory.  The proposed
// trajectory gets submitted to the mediation_layer (ML), which responds by
// setting the data member trajectoryCodeMap_.  See the header file
// game-engine/src/util/trajectory_code.h for a list of possible codes.
//
// Any code other than MediationLayer::Success indicates that the ML has
// rejected the submitted trajectory.
//
// trajectoryCodeMap_ is initialized with MediationLayerCode::Success, so this
// will be its value the first time this function is called (before any
// trajectories have been submitted).  Thereafter, trajectoryCodeMap_ will
// indicate the MediationLayerCode for the most recently submitted trajectory.
std::unordered_map<std::string, Trajectory>
ExampleAutonomyProtocol::UpdateTrajectories() {
  // The best way to get good timing without diving into ROS timers is to use
  // the C++ std::chrono library. Here are some basic pointers for using the
  // library. There are three basic types of std::chrono variables.
  //
  // 1. The "timestamp" type. Represents an absolute time point, usually
  //    relative to epoch. Generated with std::chrono::system_clock::now().
  //
  //        const std::chrono::time_point<std::chrono::system_clock>
  //        timepointVar
  //          = std::chrono::system_clock::now();
  //
  // 2. The "duration" type. Something you can use to add to and subtract from
  //    timestamps. Pretty useful. Can be generated by taking the difference
  //    between "timestamp" types, using std::chrono::duration<double>::
  //    time_since_epoch(), and std::chrono::duration_cast<...>(unitVar). You
  //    can convert these back and forth to normal C++ doubles using count() as
  //    well.
  //
  //        const std::chrono::duration<double> durationVar
  //          = timepointVar1 - timepointVar2;
  //
  //        const std::chrono::duration<double> durationVar
  //          = timepointVar.time_since_epoch();
  //
  // 3. The "unit time" type. Must be set with integer, and is confusing because
  //    it acts a lot like the "duration" type. Typically useful only if you
  //    need a quickhand way to generate some finite amount of time that isn't
  //    really related to anything in variable names. You can
  //
  //        std::chrono::milliseconds unitVar == std::chrono::milliseconds(15);
  //
  // Note that the agreed convention for trajectories passed to the mediation
  // layer requires time points measured in floating point seconds from the Unix
  // epoch. Epoch time means Jan 1st of 1970 which is a standard time of system
  // like Unix. For more information, visit
  // https://cplusplus.com/reference/chrono/.

  // First live examples of using std::chrono are below.
  // You can declare any unit of time.
  static std::chrono::milliseconds dt_chrono_u_ = std::chrono::milliseconds(40);
  // now() can get current system clock as a timepoint.
  static const std::chrono::time_point<std::chrono::system_clock>
      start_chrono_time_t_ = std::chrono::system_clock::now();
  // You can shift timepoints using durations.
  const std::chrono::milliseconds duration_chrono_d_ =
      std::chrono::seconds(duration_sec_);
  static const std::chrono::time_point<std::chrono::system_clock>
      end_chrono_time_t_ = start_chrono_time_t_ + duration_chrono_d_;

  // Load the current quad position
  const std::string& quad_name = friendly_names_[0];
  Eigen::Vector3d current_pos;
  snapshot_->Position(quad_name, current_pos);

  // All the code relating to the StartPointFarFromCurrentPosition prevetter
  // error is made for showing the example of how to deal with prevetter. You
  // better remove these part and make your own one. Prevetter flag about start
  // point far from the current position
  bool bad_pos = true;  // About start point far from the current position
  bool change_start_pos = false;  // To check whether the drone has changed the
                                  // start position or not

  // Condition actions or parameters on wind intensity.  For example, consider
  // increasing safety_margin_ with wind intensity.
  switch (wind_intensity_) {
    case WindIntensity::Zero:
      // Do something zero-ish
      break;
    case WindIntensity::Mild:
      // Do something mild
      break;
    case WindIntensity::Stiff:
      // Do something stiff
      break;
    case WindIntensity::Intense:
      // Do something intense
      break;
    case WindIntensity::Ludicrous:
      // Do something ludicrous
      break;
    default:
      std::cerr << "Unrecognized WindIntensity value." << std::endl;
      std::exit(EXIT_FAILURE);
  }

  // Set some variables the first time this function is called
  if (first_time_) {
    first_time_ = false;
    start_pos_ = current_pos;
    change_start_pos =
        true;  // To move start position on purpose only for first time
  }

  // Obtain current balloon positions and popped states
  const Eigen::Vector3d red_balloon_pos = *red_balloon_position_;
  const Eigen::Vector3d blue_balloon_pos = *blue_balloon_position_;
  const bool red_balloon_popped = red_balloon_status_->popped;
  const bool blue_balloon_popped = blue_balloon_status_->popped;

  // The following section is an example of how you might want to handle errors
  // returned by the mediation layer. For example, the default example autonomy
  // protocol initially submits trajectories where the sampling time is too high
  // - instead of 20 ms intervals or less, it submits at 40 ms intervals. Thus,
  // as the mediation layer rejects the trajectory and returns the error
  // TimeBetweenPointsExceedsMaxTime, you can write code to handle that. In this
  // case, we decrease dt_chrono by 15 ms until we pass the 20 ms bar. You can
  // fill out this switch statement with case statements tailored to each
  // possible MediationLayerCode.
  switch (trajectoryCodeMap_[quad_name].code) {
    case MediationLayerCode::Success:
      // You probably won't need to do anything in response to Success.
      break;
    case MediationLayerCode::TimeBetweenPointsExceedsMaxTime: {
      // Suppose your AP initially submits a trajectory with a time that exceeds
      // the maximum allowed time between points. You could fix the problem as
      // shown below.
      std::cout << "Replanning trajectory: "
                   "Shortening time between trajectory points."
                << std::endl;
      std::cout << "Value: " << trajectoryCodeMap_[quad_name].value
                << std::endl;
      dt_chrono_u_ = dt_chrono_u_ - std::chrono::milliseconds(15);
      break;
    }
    default:
      // If you want to see a numerical MediationLayerCode value, you can cast
      // and print the code as shown below.
      std::cout << "MediationLayerCode: "
                << static_cast<int>(trajectoryCodeMap_[quad_name].code)
                << std::endl;
      std::cout << "Value: " << trajectoryCodeMap_[quad_name].value
                << std::endl;
      std::cout << "Index: " << trajectoryCodeMap_[quad_name].index
                << std::endl;
  }

  // More examples of std::chrono use!
  // To get how many ticks are counted in a chrono duration time, count() should
  // be used. Effectively, this converts from a from a unit to a duration.
  const double dt =
      std::chrono::duration_cast<std::chrono::duration<double>>(dt_chrono_u_)
          .count();
  // You can construct a time_point using now().
  const std::chrono::time_point<std::chrono::system_clock>
      current_chrono_time_t_ = std::chrono::system_clock::now();
  // This code makes a duration by taking the difference between timepoints.
  const std::chrono::duration<double> remaining_chrono_time_d_ =
      end_chrono_time_t_ - current_chrono_time_t_;

  // The following code generates and returns a new trajectory each time it
  // runs.  The new trajectory starts at the location on the original circle
  // that is closest to the current location of the quad and it creates a
  // trajectory of N position, velocity, and acceleration (PVA) points spaced by
  // dt seconds.  Thus, the code below responds to the actual position of the
  // quad and adjusts the newly-generated trajectory accordingly.  But note that
  // its strategy is not optimal for covering the greatest distance in the
  // allotted time in the presence of disturbance accelerations.

  // Number of samples in new trajectory
  const size_t N = remaining_chrono_time_d_ / dt_chrono_u_;

  // Create an empty quad-to-trajectory map.  This map object associates a quad
  // name (expressed as a std::string) with the corresponding Trajectory object.
  std::unordered_map<std::string, Trajectory> quad_to_trajectory_map;

  // If the end time has passed, or if there are too few samples for a valid
  // trajectory, return an empty quad_to_trajectory_map
  constexpr size_t min_required_samples_in_trajectory = 2;
  if (current_chrono_time_t_ >= end_chrono_time_t_ ||
      N < min_required_samples_in_trajectory) {
    return quad_to_trajectory_map;
  }

  // This while loop helps determine where to jump back to, if the prevetter
  // finds a fault with the submitted trajectory. There is a paragraph
  // explanation of the prevetter functionality below.
  while (bad_pos == true) {
    // Halt at goal position when close enough
    constexpr double goal_arrival_threshold_meters = 0.3;
    const Eigen::Vector3d dv = current_pos - goal_position_;
    // TrajectoryVector3D is an std::vector object defined in trajectory.h
    TrajectoryVector3D trajectory_vector;
    if (halt_ ||
        (remaining_chrono_time_d_ < std::chrono::seconds(duration_sec_ - 10) &&
         dv.norm() < goal_arrival_threshold_meters)) {
      halt_ = true;
      for (size_t idx = 0; idx < 20; ++idx) {
        const std::chrono::duration<double> flight_chrono_time_d_ =
            current_chrono_time_t_.time_since_epoch() + idx * dt_chrono_u_;
        const double flight_time = flight_chrono_time_d_.count();
        trajectory_vector.push_back(
            (Eigen::Matrix<double, 11, 1>() << goal_position_.x(),
             goal_position_.y(), goal_position_.z(), 0, 0, 0, 0, 0, 0, 0,
             flight_time)
                .finished());
      }
      Trajectory trajectory(trajectory_vector);
      visualizer_.drawTrajectory(trajectory);
      quad_to_trajectory_map[quad_name] = trajectory;
      return quad_to_trajectory_map;
    }

    // Generate the trajectory to red balloon
    std::vector<Eigen::Vector3d> waypoints;

    // REMOVE THIS: This section of code helps demonstrate use of the prevetter.
    // You may fix this by removing fields and code related to bad_pos and
    // change_pos when you flesh out your own autonomy protocol. This code
    // injects a start position error by artificially moving the start position
    // by some random numbers. After the prevetter complains, we say, "Ahhh you
    // caught me," and then stop injecting the error.
    if (change_start_pos == true) {
      waypoints.push_back(current_pos - Eigen::Vector3d(3.2, 1.6, -2.1));
    } else {
      waypoints.push_back(current_pos);
    }

    waypoints.push_back(red_balloon_pos);

    // Return the start position to current position
    if (bad_pos == true && change_start_pos == false) {
      waypoints[0] = current_pos;
    }

    bad_pos = false;
    change_start_pos = false;

    // Generate waypoint arrival-time estimates
    std::vector<double> times;
    times.push_back(0);
    times.push_back((red_balloon_pos - current_pos).norm() /
                    (red_balloon_pos - start_pos_).norm() * 30);

    // The parameter order for p4::NodeEqualityBound is: (dimension_index,
    // node_idx, derivative_idx, value) The trajectory must start at the current
    // position
    std::vector<p4::NodeEqualityBound> node_equality_bounds = {
        p4::NodeEqualityBound(0, 0, 0, waypoints[0].x()),
        p4::NodeEqualityBound(1, 0, 0, waypoints[0].y()),
        p4::NodeEqualityBound(2, 0, 0, waypoints[0].z()),
    };

    // A Node inequality bound defines a range of acceptable values for a
    // constraint instead of a single value. The parameter order for
    // p4::NodeInequalityBound is: (dimension_index, node_idx, derivative_idx,
    // lower_bound, upper_bound) In this example, node inequality bounds are
    // used to constrain the trajectory positions in order to hit the balloons.
    // These bounds specify 0.2m x 0.2m x 0.2m boxes centered around the balloon
    // centers.
    const double p_bound = 0.1;
    std::vector<p4::NodeInequalityBound> node_inequality_bounds;
    for (int w = 1; w < waypoints.size(); w++) {
      node_inequality_bounds.push_back(p4::NodeInequalityBound(
          0, w, 0, waypoints[w].x() - p_bound, waypoints[w].x() + p_bound));
      node_inequality_bounds.push_back(p4::NodeInequalityBound(
          1, w, 0, waypoints[w].y() - p_bound, waypoints[w].y() + p_bound));
      node_inequality_bounds.push_back(p4::NodeInequalityBound(
          2, w, 0, waypoints[w].z() - p_bound, waypoints[w].z() + p_bound));
    }

    // A segment is defined to be the path connecting two consecutive nodes. A
    // segment inequality bound the following linear inequality as a constraing
    // on the segment: dot(a,x) < b. The x vector is the derivative vector, the
    // a vector is its corresponding coefficient vector, and the scalar b is a
    // chosen maximum. The parameter order for p4::SegmentInequalityBound is:
    // (segment_idx, derivative_idx, coefficient_vector (a), value (b)). In this
    // example, velocity is constrained to a magnitude between -1.5 m/s and +1.5
    // m/s along each axis for every segment in the trajectory
    const double v_bound = 1.5;
    std::vector<p4::SegmentInequalityBound> segment_inequality_bounds;
    for (int w = 0; w < waypoints.size() - 1; w++) {
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(1, 0, 0), v_bound));
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(0, 1, 0), v_bound));
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(0, 0, 1), v_bound));
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(-1, 0, 0), v_bound));
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(0, -1, 0), v_bound));
      segment_inequality_bounds.push_back(
          p4::SegmentInequalityBound(w, 1, Eigen::Vector3d(0, 0, -1), v_bound));
    }

    // Options to configure the polynomial solver with
    p4::PolynomialSolver::Options solver_options;
    solver_options.num_dimensions = 3;    // 3D
    solver_options.polynomial_order = 8;  // Fit an 8th-order polynomial
    solver_options.continuity_order = 4;  // Require continuity to the 4th order
    solver_options.derivative_order =
        2;  // Minimize the 2nd order (acceleration)

    osqp_set_default_settings(&solver_options.osqp_settings);
    solver_options.osqp_settings.polish =
        true;  // Polish the solution, getting the best answer possible
    solver_options.osqp_settings.verbose = false;  // Suppress the printout
    // Use p4::PolynomialSolver object to solve for polynomial trajectories
    p4::PolynomialSolver solver(solver_options);
    const p4::PolynomialSolver::Solution path =
        solver.Run(times, node_equality_bounds, node_inequality_bounds,
                   segment_inequality_bounds);

    // Sampling Polynomial Trajectory
    {
      // Options to configure the polynomial sampler with
      p4::PolynomialSampler::Options sampler_options;
      sampler_options.frequency = 300;  // Number of samples per second

      sampler_options.derivative_order = 0;  // Derivative to sample (0 = pos)
      std::vector<double> x_hist, y_hist, z_hist;
      BuildHistoryVectors(times, path, sampler_options, x_hist, y_hist, z_hist);

      sampler_options.derivative_order = 1;
      std::vector<double> vx_hist, vy_hist, vz_hist;
      BuildHistoryVectors(times, path, sampler_options, vx_hist, vy_hist,
                          vz_hist);

      sampler_options.derivative_order = 2;
      std::vector<double> ax_hist, ay_hist, az_hist;
      BuildHistoryVectors(times, path, sampler_options, ax_hist, ay_hist,
                          az_hist);

      const double yaw = 0.0;

      int dt_chrono_count_sq = pow(dt_chrono_u_.count(), 2);
      for (size_t time_idx = 0; time_idx < x_hist.size(); ++time_idx) {
        const std::chrono::duration<double> flight_chrono_time_d_ =
            current_chrono_time_t_.time_since_epoch() + time_idx * dt_chrono_u_;

        // Time must be specified as a floating point number that measures the
        // number of seconds since the Unix epoch.
        const double flight_time = flight_chrono_time_d_.count();

        // Push matrix packed with a trajectory point onto the trajectory vector
        trajectory_vector.push_back(
            (Eigen::Matrix<double, 11, 1>() << x_hist[time_idx],
             y_hist[time_idx], z_hist[time_idx], vx_hist[time_idx],
             vy_hist[time_idx], vz_hist[time_idx], ax_hist[time_idx],
             ay_hist[time_idx], az_hist[time_idx], yaw, flight_time)
                .finished());
      }

      // Construct a trajectory from the trajectory vector
      Trajectory trajectory(trajectory_vector);

      // Before submitting the trajectory, if you wish, you can use this
      // prevetting interface to determine if the trajectory violates any
      // mediation layer constraints. It works very similarly to the mediation
      // layer error handling much further up in the script, with the only
      // difference being that you can use this to double check your submitted
      // trajectory before mediation layer ever has to see it. Assuming it
      // doesn't pass the final check, you can jump back up to a certain part of
      // the code through a variety of means, where you can then compensate for
      // the error and try again. An example has been included that shows how
      // one might handle a bad starting position with a while loop on the
      // trajectory generation step. Remove fields and lines of code related to
      // bad_pos and

      // Further details that might help you understand how to utilize all
      // features of the prevetting: This interface's source code can be found
      // in presubmission_trajectory_vetter.h. The PreVet function returns type
      // TrajectoryCode which contains three values: (1) The mediation layer
      // code that specifies success or the failure; (2) The failure value
      // (e.g., if the velocity limit is 4.0 m/s and you submit 5.0 m/s, the
      // value is returned as 5.0); (3) The failure index. This is the
      // trajectory sample index that caused the mediation layer to kick back an
      // error code. The index is the sampled index (specified from the P4
      // sampling process). You can figure out the waypoint index by a simple
      // math transformation.
      TrajectoryCode prevetter_response =
          prevetter_->PreVet(quad_name, trajectory, map3d_);
      switch (prevetter_response.code) {
        case MediationLayerCode::Success: {
          // You probably won't need to do anything in response to Success.
          break;
        }
        case MediationLayerCode::TimeBetweenPointsExceedsMaxTime: {
          // Suppose your AP intends to submit a trajectory with a time that
          // exceeds the maximum allowed time between points. The prevetter
          // would catch this before you submit to the mediation layer.
          std::cout << "Prevet: Shorten time between trajectory points."
                    << std::endl;
          std::cout << "Prevet: Time violation: " << prevetter_response.value
                    << std::endl;
          break;
        }
        case MediationLayerCode::StartPointFarFromCurrentPosition: {
          std::cout << "Prevet: Start point far from current position"
                    << std::endl;
          std::cout << "Prevet: Position violation: "
                    << prevetter_response.value << std::endl;
          bad_pos = true;
          break;
        }
        default:
          std::cout << "Prevet code: "
                    << static_cast<int>(prevetter_response.code) << std::endl;
          std::cout << "Prevet value: " << prevetter_response.value
                    << std::endl;
          std::cout << "Prevet index: " << prevetter_response.index
                    << std::endl;
      }

      // Invoke the visualizer to see the proposed trajectory, which will be
      // displayed in violet. See autonomy_protocol_visualizer.h for other
      // visualization options: you can visualize a short path, a single point,
      // etc. It will be helpful to get such visual feedback on candidate
      // trajectories. Note that there is a built-in visualizer called
      // "ViewManager" implemented elsewhere in the game-engine code, but you
      // don't have full control over what it displays like you do with the
      // visualizer invoked below.
      visualizer_.drawTrajectory(trajectory);
      quad_to_trajectory_map[quad_name] = trajectory;
    }

    // To break out the while loop, if prevet(StartPointFarFromCurrentPosition)
    // is passed
    if (bad_pos == false) {
      break;
    }
    // Sleep for 5 seconds and make warning during start position is located on
    // weird position.
    else {
      for (int re = 0; re < 5; re++) {
        std::cout << "Warning: Move start point" << std::endl;
        sleep(1);
      }
    }
  }

  return quad_to_trajectory_map;
}
}  // namespace game_engine
